;;; Monster hurt

	STX temp
	GetActionStep temp
	CMP #7 ;; We will use action step 7 for hurt.
	BNE +dontSkipHurtingMonster
		JMP +skipDestroyingThisMonster ;; If he is hurt, he can't be hurt again.
	+dontSkipHurtingMonster:
		ChangeActionStep temp, #7
		
		DEC Object_health,x
		LDA Object_health,x
		BEQ destroyMonster
			JMP +skipDestroyingThisMonster
		destroyMonster:
			LDA Object_x_hi,x
			STA tempA
			LDA Object_y_hi,x
			STA tempB
			LDA Object_screen,x
			STA tempC
			
			;;; Adjust monster type to use drop table
			LDA Object_type,x
			SEC
			SBC #16 ;;; We skip game objects
			STA tempMonster
			
			;;; Destroy monster
			DestroyObject
			
			;PlaySound #sfx_monsterDeath
			
			;;; Create monster death object (game object 8)
			CreateObjectOnScreen tempA, tempB, #8, #0, tempC
			
			
			;;; ----------------- Create random drop based on drop table -----------------
			TXA
			PHA
			TYA
			PHA
			
			LDY tempMonster ;;; Monster number (adjusted to use drop tables)
			
			LDA MonsterDropTables,y
			TAY
			
			LDA DropTable_LO,y
			STA dropLO
			LDA DropTable_HI,y
			STA dropHI
			
			;;; Get a random number between 0 and 7
			JSR doGetRandomNumber
			AND #%00000111
			TAY
			
			LDA (dropLO),y
			CMP #255 ;;; Code for no drop
			BNE createDrop
				;;; Exit drop routine
				JMP skipDrop
			createDrop:
				;;; Create drop object
				STA temp
				CreateObjectOnScreen tempA, tempB, temp, #0, tempC
			
			skipDrop:
			
			PLA
			TAY
			PLA
			TAX
			;;; --------------------------------------------------------------------------
			
	+skipDestroyingThisMonster:
